(ns wanijo.main
  (:require [ring.adapter.jetty :refer [run-jetty]]
            [wanijo.handler :as wanijo-handler])
  (:gen-class))

(defonce server (atom nil))

(defn start-server!
  [& {:keys [port join? handler]
      :or {port 3080
           join? true
           handler wanijo-handler/standalone-app}}]
  (reset! server
          (run-jetty wanijo-handler/standalone-app
                     {:port port
                      :join? join?})))

(defn start-server-dev! []
  (start-server! :join? false
                 :port 8080
                 :handler wanijo-handler/dev-app))

(defn stop-server! []
  (.stop @server))

(defn -main [& args]
  (start-server! :port (Integer/valueOf (or (System/getenv "port")
                                            "3080"))
                 :join? false))
